Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/DYN/dynvor.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/DYN/dynvor.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/DYN/dynvor.F90	(revision 14062)
@@ -898,4 +993,5 @@
          CASE( np_ENE )   ;   WRITE(numout,*) '   ==>>>   energy conserving scheme (Coriolis at F-points) (ENE)'
          CASE( np_ENT )   ;   WRITE(numout,*) '   ==>>>   energy conserving scheme (Coriolis at T-points) (ENT)'
+                              IF( ln_dynadv_vec )   CALL ctl_warn('dyn_vor_init: ENT scheme may not work in vector form')
          CASE( np_EET )   ;   WRITE(numout,*) '   ==>>>   energy conserving scheme (EEN scheme using e3t) (EET)'
          CASE( np_EEN )   ;   WRITE(numout,*) '   ==>>>   energy and enstrophy conserving scheme (EEN)'
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/DYN/sshwzv.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/DYN/sshwzv.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/DYN/sshwzv.F90	(revision 14062)
@@ -6,9 +6,10 @@
    !! History :  3.1  !  2009-02  (G. Madec, M. Leclair)  Original code
    !!            3.3  !  2010-04  (M. Leclair, G. Madec)  modified LF-RA 
-   !!             -   !  2010-05  (K. Mogensen, A. Weaver, M. Martin, D. Lea) Assimilation interface
-   !!             -   !  2010-09  (D.Storkey and E.O'Dea) bug fixes for BDY module
-   !!            3.3  !  2011-10  (M. Leclair) split former ssh_wzv routine and remove all vvl related work
-   !!            4.0  !  2018-12  (A. Coward) add mixed implicit/explicit advection
-   !!            4.1  !  2019-08  (A. Coward, D. Storkey) Rename ssh_nxt -> ssh_atf. Now only does time filtering.
+   !!             -   !  2010-05  (K. Mogensen, A. Weaver, M. Martin, D. Lea)  Assimilation interface
+   !!             -   !  2010-09  (D.Storkey and E.O'Dea)  bug fixes for BDY module
+   !!            3.3  !  2011-10  (M. Leclair)  split former ssh_wzv routine and remove all vvl related work
+   !!            4.0  !  2018-12  (A. Coward)  add mixed implicit/explicit advection
+   !!            4.1  !  2019-08  (A. Coward, D. Storkey)  Rename ssh_nxt -> ssh_atf. Now only does time filtering.
+   !!             -   !  2020-08  (S. Techene, G. Madec)  add here ssh initiatlisation
    !!----------------------------------------------------------------------
 
@@ -17,4 +18,5 @@
    !!   ssh_atf       : time filter the ssh arrays
    !!   wzv           : compute now vertical velocity
+   !!   ssh_init_rst  : ssh set from restart or domcfg.nc file or usr_def_istat_ssh
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers variables
@@ -40,17 +42,18 @@
    USE timing         ! Timing
    USE wet_dry        ! Wetting/Drying flux limiting
-
+   USE usrdef_istate, ONLY : usr_def_istate_ssh   ! user defined ssh initial state 
+   
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   ssh_nxt    ! called by step.F90
-   PUBLIC   wzv        ! called by step.F90
-   PUBLIC   wAimp      ! called by step.F90
-   PUBLIC   ssh_atf    ! called by step.F90
+   PUBLIC   ssh_nxt        ! called by step.F90
+   PUBLIC   wzv            ! called by step.F90
+   PUBLIC   wAimp          ! called by step.F90
+   PUBLIC   ssh_atf        ! called by step.F90
+   PUBLIC   ssh_init_rst   ! called by domain.F90
 
    !! * Substitutions
 #  include "do_loop_substitute.h90"
 #  include "domzgr_substitute.h90"
-
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -299,4 +302,5 @@
          !                                                  ! filtered "now" field
          pssh(:,:,Kmm) = pssh(:,:,Kmm) + rn_atfp * ( pssh(:,:,Kbb) - 2 * pssh(:,:,Kmm) + pssh(:,:,Kaa) )
+         !
          IF( .NOT.ln_linssh ) THEN                          ! "now" <-- with forcing removed
             zcoef = rn_atfp * rn_Dt * r1_rho0
@@ -307,10 +311,11 @@
 
             ! ice sheet coupling
-            IF ( ln_isf .AND. ln_isfcpl .AND. kt == nit000+1) pssh(:,:,Kbb) = pssh(:,:,Kbb) - rn_atfp * rn_Dt * ( risfcpl_ssh(:,:) - 0.0 ) * ssmask(:,:)
+            IF( ln_isf .AND. ln_isfcpl .AND. kt == nit000+1 )   &
+               &   pssh(:,:,Kbb) = pssh(:,:,Kbb) - rn_atfp * rn_Dt * ( risfcpl_ssh(:,:) - 0.0 ) * ssmask(:,:)
 
          ENDIF
       ENDIF
       !
-      IF(sn_cfctl%l_prtctl)   CALL prt_ctl( tab2d_1=pssh(:,:,Kmm), clinfo1=' pssh(:,:,Kmm)  - : ', mask1=tmask )
+      IF(sn_cfctl%l_prtctl)   CALL prt_ctl( tab2d_1=pssh(:,:,Kmm), clinfo1=' atf  - pssh(:,:,Kmm): ', mask1=tmask )
       !
       IF( ln_timing )   CALL timing_stop('ssh_atf')
@@ -431,4 +436,87 @@
       !
    END SUBROUTINE wAimp
+
+
+   SUBROUTINE ssh_init_rst( Kbb, Kmm, Kaa )
+      !!---------------------------------------------------------------------
+      !!                   ***  ROUTINE ssh_init_rst  ***
+      !!
+      !! ** Purpose :   ssh initialization of the sea surface height (ssh)
+      !!
+      !! ** Method  :   set ssh from restart or read configuration, or user_def
+      !!              * ln_rstart = T
+      !!                   USE of IOM library to read ssh in the restart file
+      !!                   Leap-Frog: Kbb and Kmm are read except for l_1st_euler=T
+      !!
+      !!              * otherwise 
+      !!                   call user defined ssh or
+      !!                   set to -ssh_ref in wet and drying case with domcfg.nc
+      !!
+      !!              NB: ssh_b/n are written by restart.F90
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   Kbb, Kmm, Kaa   ! ocean time level indices
+      !
+      INTEGER ::   ji, jj, jk
+      !!----------------------------------------------------------------------
+      !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'ssh_init_rst : ssh initialization'
+         WRITE(numout,*) '~~~~~~~~~~~~ '
+      ENDIF
+      !
+      !                            !=============================!
+      IF( ln_rstart ) THEN         !==  Read the restart file  ==!
+         !                         !=============================!
+         !
+         !                                     !*  Read ssh at Kmm
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*)    '      Kmm sea surface height read in the restart file'
+         CALL iom_get( numror, jpdom_auto, 'sshn'   , ssh(:,:,Kmm) )
+         !
+         IF( l_1st_euler ) THEN                !* Euler at first time-step
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) '      Euler first time step : ssh(Kbb) = ssh(Kmm)'
+            ssh(:,:,Kbb) = ssh(:,:,Kmm)
+            !
+         ELSE                                  !* read ssh at Kbb
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) '      Kbb sea surface height read in the restart file'
+            CALL iom_get( numror, jpdom_auto, 'sshb', ssh(:,:,Kbb) )
+         ENDIF
+         !                         !============================!
+      ELSE                         !==  Initialize at "rest"  ==!
+         !                         !============================!
+         !
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*)    '      initialization at rest'
+         !
+         IF( ll_wd ) THEN                      !* wet and dry 
+            !
+            IF( ln_read_cfg  ) THEN                 ! read configuration : ssh_ref is read in domain_cfg file
+!!st  why ssh is not masked : i.e. ssh(:,:,Kmm) = -ssh_ref*ssmask(:,:),
+!!st  since at the 1st time step lbclnk will be applied on ssh at Kaa but not initially at Kbb and Kmm
+               ssh(:,:,Kbb) = -ssh_ref
+               !
+               DO_2D( 1, 1, 1, 1 )
+                  IF( ht_0(ji,jj)-ssh_ref <  rn_wdmin1 ) THEN   ! if total depth is less than min depth
+                     ssh(ji,jj,Kbb) = rn_wdmin1 - ht_0(ji,jj)
+                  ENDIF
+               END_2D
+            ELSE                                    ! user define configuration case  
+               CALL usr_def_istate_ssh( tmask, ssh(:,:,Kbb) )
+            ENDIF
+            !
+         ELSE                                  !* user defined configuration
+            CALL usr_def_istate_ssh( tmask, ssh(:,:,Kbb) )
+            !
+         ENDIF
+         !
+         ssh(:,:,Kmm) = ssh(:,:,Kbb)           !* set now values from to before ones
+         ssh(:,:,Kaa) = 0._wp 
+      ENDIF
+      !
+   END SUBROUTINE ssh_init_rst
+      
    !!======================================================================
 END MODULE sshwzv
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/IOM/iom.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/IOM/iom.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/IOM/iom.F90	(revision 14062)
@@ -174,4 +174,5 @@
          CALL set_grid( "V", glamv, gphiv, .FALSE., .FALSE. )
          CALL set_grid( "W", glamt, gphit, .FALSE., .FALSE. )
+         CALL set_grid( "F", glamf, gphif, .FALSE., .FALSE. )
          CALL set_grid_znl( gphit )
          !
@@ -180,9 +181,11 @@
             CALL iom_set_domain_attr("grid_U", area = real( e1e2u(Nis0:Nie0, Njs0:Nje0), dp))
             CALL iom_set_domain_attr("grid_V", area = real( e1e2v(Nis0:Nie0, Njs0:Nje0), dp))
-            CALL iom_set_domain_attr("grid_W", area = real( e1e2t(Nis0:Nie0, Njs0:Nje0), dp))
+            CALL iom_set_domain_attr("grid_W", area = REAL( e1e2t(Nis0:Nie0, Njs0:Nje0), dp))
+            CALL iom_set_domain_attr("grid_F", area = real( e1e2f(Nis0:Nie0, Njs0:Nje0), dp))
             CALL set_grid_bounds( "T", glamf, gphif, glamt, gphit )
             CALL set_grid_bounds( "U", glamv, gphiv, glamu, gphiu )
             CALL set_grid_bounds( "V", glamu, gphiu, glamv, gphiv )
             CALL set_grid_bounds( "W", glamf, gphif, glamt, gphit )
+            CALL set_grid_bounds( "F", glamt, gphit, glamf, gphif )
          ENDIF
       ENDIF
@@ -191,8 +194,8 @@
          CALL dom_grid_crs   ! Save the parent grid information  & Switch to coarse grid domain
          !
-         CALL set_grid( "T", glamt_crs, gphit_crs, .FALSE., .FALSE. ) 
-         CALL set_grid( "U", glamu_crs, gphiu_crs, .FALSE., .FALSE. ) 
-         CALL set_grid( "V", glamv_crs, gphiv_crs, .FALSE., .FALSE. ) 
-         CALL set_grid( "W", glamt_crs, gphit_crs, .FALSE., .FALSE. ) 
+         CALL set_grid( "T", glamt_crs, gphit_crs, .FALSE., .FALSE. )
+         CALL set_grid( "U", glamu_crs, gphiu_crs, .FALSE., .FALSE. )
+         CALL set_grid( "V", glamv_crs, gphiv_crs, .FALSE., .FALSE. )
+         CALL set_grid( "W", glamt_crs, gphit_crs, .FALSE., .FALSE. )
          CALL set_grid_znl( gphit_crs )
           !
@@ -217,4 +220,5 @@
          CALL iom_set_axis_attr(  "depthv", paxis = gdept_1d )
          CALL iom_set_axis_attr(  "depthw", paxis = gdepw_1d )
+          CALL iom_set_axis_attr(  "depthf", paxis = gdept_1d )
 
           ! ABL
@@ -238,4 +242,5 @@
          CALL iom_set_axis_attr(  "depthv", bounds=zw_bnds )
          CALL iom_set_axis_attr(  "depthw", bounds=zt_bnds )
+          CALL iom_set_axis_attr(  "depthf", bounds=zw_bnds )
 
          ! ABL
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/IOM/restart.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/IOM/restart.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/IOM/restart.F90	(revision 14062)
@@ -11,4 +11,5 @@
    !!            3.7  !  2014-01  (G. Madec) suppression of curl and hdiv from the restart
    !!             -   !  2014-12  (G. Madec) remove KPP scheme
+   !!            4.1  !  2020-11  (S. Techene, G. Madec)  move ssh initiatlisation in DYN/sshwzv:ssh_init_rst
    !!----------------------------------------------------------------------
 
@@ -139,4 +140,7 @@
       !! ** Method  :   Write in numrow when kt == nitrst in NetCDF
       !!              file, save fields which are necessary for restart
+      !!
+      !!                NB: ssh is written here (rst_write)
+      !!                    but is read or set in DYN/sshwzv:shh_init_rst
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt         ! ocean time-step
@@ -233,32 +237,24 @@
       !!                   ***  ROUTINE rst_read  ***
       !! 
-      !! ** Purpose :   Read files for NetCDF restart
-      !! 
-      !! ** Method  :   Read in restart.nc file fields which are necessary for restart
+      !! ** Purpose :   Read velocity and T-S fields in the restart file
+      !! 
+      !! ** Method  :   Read in restart.nc fields which are necessary for restart
+      !!
+      !!                NB: restart file openned           in DOM/domain.F90:dom_init
+      !!                    before field in restart tested in DOM/domain.F90:dom_init
+      !!                    (sshb)
+      !!
+      !!                NB: ssh is read or set in DYN/sshwzv:shh_init_rst
+      !!                    but is written     in IOM/restart:rst_write
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   Kbb, Kmm   ! ocean time level indices
-      REAL(wp) ::   zrdt
       INTEGER  ::   jk
       REAL(wp), DIMENSION(jpi, jpj, jpk) :: w3d
       !!----------------------------------------------------------------------
-
-      CALL rst_read_open           ! open restart for reading (if not already opened)
-
-      ! Check dynamics and tracer time-step consistency and force Euler restart if changed
-      IF( iom_varid( numror, 'rdt', ldstop = .FALSE. ) > 0 )   THEN
-         CALL iom_get( numror, 'rdt', zrdt )
-         IF( zrdt /= rn_Dt ) THEN
-            IF(lwp) WRITE( numout,*)
-            IF(lwp) WRITE( numout,*) 'rst_read:  rdt not equal to the read one'
-            IF(lwp) WRITE( numout,*)
-            IF(lwp) WRITE( numout,*) '      ==>>>   forced euler first time-step'
-            l_1st_euler =  .TRUE.
-         ENDIF
-      ENDIF
-
+      !
       IF(.NOT.lrxios ) CALL iom_delay_rst( 'READ', 'OCE', numror )   ! read only ocean delayed global communication variables
-      
-      ! Diurnal DSST 
-      IF( ln_diurnal ) CALL iom_get( numror, jpdom_auto, 'Dsst' , x_dsst ) 
+      !
+      !                             !*  Diurnal DSST 
+      IF( ln_diurnal )   CALL iom_get( numror, jpdom_auto, 'Dsst' , x_dsst ) 
       IF ( ln_diurnal_only ) THEN 
          IF(lwp) WRITE( numout, * ) &
@@ -269,22 +265,25 @@
          RETURN 
       ENDIF  
-
-      IF( iom_varid( numror, 'ub', ldstop = .FALSE. ) > 0 ) THEN
-         ! before fields
+      !
+      !                             !*  Read Kmm fields
+      IF(lwp) WRITE(numout,*)    '           Kmm u, v and T-S fields read in the restart file'
+      CALL iom_get( numror, jpdom_auto, 'un'     , uu(:,:,:       ,Kmm), cd_type = 'U', psgn = -1._wp )
+      CALL iom_get( numror, jpdom_auto, 'vn'     , vv(:,:,:       ,Kmm), cd_type = 'V', psgn = -1._wp )
+      CALL iom_get( numror, jpdom_auto, 'tn'     , ts(:,:,:,jp_tem,Kmm) )
+      CALL iom_get( numror, jpdom_auto, 'sn'     , ts(:,:,:,jp_sal,Kmm) )
+      !
+      IF( l_1st_euler ) THEN        !*  Euler restart
+         IF(lwp) WRITE(numout,*) '           Kbb u, v and T-S fields set to Kmm values'
+         ts(:,:,:,:,Kbb) = ts(:,:,:,:,Kmm)         ! all before fields set to now values
+         uu(:,:,:  ,Kbb) = uu(:,:,:  ,Kmm)
+         vv(:,:,:  ,Kbb) = vv(:,:,:  ,Kmm)
+      ELSE                          !* Leap frog restart
+         IF(lwp) WRITE(numout,*) '           Kbb u, v and T-S fields read in the restart file'
          CALL iom_get( numror, jpdom_auto, 'ub'     , uu(:,:,:       ,Kbb), cd_type = 'U', psgn = -1._wp )
          CALL iom_get( numror, jpdom_auto, 'vb'     , vv(:,:,:       ,Kbb), cd_type = 'V', psgn = -1._wp )
          CALL iom_get( numror, jpdom_auto, 'tb'     , ts(:,:,:,jp_tem,Kbb) )
          CALL iom_get( numror, jpdom_auto, 'sb'     , ts(:,:,:,jp_sal,Kbb) )
-         CALL iom_get( numror, jpdom_auto, 'sshb'   ,ssh(:,:         ,Kbb) )
-      ELSE
-         l_1st_euler =  .TRUE.      ! before field not found, forced euler 1st time-step
-      ENDIF
-      !
-      ! now fields
-      CALL iom_get( numror, jpdom_auto, 'un'     , uu(:,:,:       ,Kmm), cd_type = 'U', psgn = -1._wp )
-      CALL iom_get( numror, jpdom_auto, 'vn'     , vv(:,:,:       ,Kmm), cd_type = 'V', psgn = -1._wp )
-      CALL iom_get( numror, jpdom_auto, 'tn'     , ts(:,:,:,jp_tem,Kmm) )
-      CALL iom_get( numror, jpdom_auto, 'sn'     , ts(:,:,:,jp_sal,Kmm) )
-      CALL iom_get( numror, jpdom_auto, 'sshn'   ,ssh(:,:         ,Kmm) )
+      ENDIF
+      !
       IF( iom_varid( numror, 'rhop', ldstop = .FALSE. ) > 0 ) THEN
          CALL iom_get( numror, jpdom_auto, 'rhop'   , rhop )   ! now    potential density
@@ -293,11 +292,4 @@
       ENDIF
       !
-      IF( l_1st_euler ) THEN                                  ! Euler restart 
-         ts   (:,:,:,:,Kbb) = ts   (:,:,:,:,Kmm)              ! all before fields set to now values
-         uu   (:,:,:  ,Kbb) = uu   (:,:,:  ,Kmm)
-         vv   (:,:,:  ,Kbb) = vv   (:,:,:  ,Kmm)
-         ssh  (:,:    ,Kbb) = ssh  (:,:    ,Kmm)
-      ENDIF
-      !
    END SUBROUTINE rst_read
 
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfcpl.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfcpl.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfcpl.F90	(revision 14062)
@@ -10,19 +10,19 @@
 
    !!----------------------------------------------------------------------
-   !!   isfrst : read/write iceshelf variables in/from restart
+   !!   isfrst        : read/write iceshelf variables in/from restart
    !!----------------------------------------------------------------------
-   USE isf_oce                          ! ice shelf variable
+   USE oce            ! ocean dynamics and tracers
+#if defined key_qco
+   USE domqco  , ONLY : dom_qco_zgr      ! vertical scale factor interpolation
+#else
+   USE domvvl  , ONLY : dom_vvl_zgr      ! vertical scale factor interpolation
+#endif
+   USE domutl  , ONLY : dom_ngb          ! find the closest grid point from a given lon/lat position
+   USE isf_oce        ! ice shelf variable
    USE isfutils, ONLY : debug
-   USE lib_mpp , ONLY: mpp_sum, mpp_max ! mpp routine
-#if ! defined key_qco
-   USE domvvl  , ONLY: dom_vvl_zgr      ! vertical scale factor interpolation
-#else
-   USE domqco   , ONLY: dom_qco_zgr      ! vertical scale factor interpolation
-#endif
-   USE domutl  , ONLY: dom_ngb          ! find the closest grid point from a given lon/lat position
    !
-   USE oce            ! ocean dynamics and tracers
    USE in_out_manager ! I/O manager
    USE iom            ! I/O library
+   USE lib_mpp , ONLY : mpp_sum, mpp_max ! mpp routine
    !
    IMPLICIT NONE
@@ -34,13 +34,13 @@
 
    TYPE isfcons
-      INTEGER :: ii     ! i global
-      INTEGER :: jj     ! j global
-      INTEGER :: kk     ! k level
-      REAL(wp):: dvol   ! volume increment
-      REAL(wp):: dsal   ! salt increment
-      REAL(wp):: dtem   ! heat increment
-      REAL(wp):: lon    ! lon
-      REAL(wp):: lat    ! lat
-      INTEGER :: ngb    ! 0/1 (valid location or not (ie on halo or no neigbourg))
+      INTEGER ::   ii     ! i global
+      INTEGER ::   jj     ! j global
+      INTEGER ::   kk     ! k level
+      REAL(wp)::   dvol   ! volume increment
+      REAL(wp)::   dsal   ! salt increment
+      REAL(wp)::   dtem   ! heat increment
+      REAL(wp)::   lon    ! lon
+      REAL(wp)::   lat    ! lat
+      INTEGER ::   ngb    ! 0/1 (valid location or not (ie on halo or no neigbourg))
    END TYPE
    !
@@ -121,6 +121,7 @@
 #endif 
    END SUBROUTINE isfcpl_init
-   ! 
-   SUBROUTINE isfcpl_rst_write(kt, Kmm)
+
+   
+   SUBROUTINE isfcpl_rst_write( kt, Kmm )
       !!---------------------------------------------------------------------
       !!                   ***  ROUTINE iscpl_rst_write  ***
@@ -133,5 +134,5 @@
       !!----------------------------------------------------------------------
       INTEGER :: jk                               ! loop index
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ze3t, ze3u, ze3v, zgdepw  ! e3t , e3u, e3v !!st patch to use substitution
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ze3t, ze3u, ze3v, zgdepw  ! for qco substitution
       !!----------------------------------------------------------------------
       !
@@ -153,4 +154,5 @@
    END SUBROUTINE isfcpl_rst_write
 
+   
    SUBROUTINE isfcpl_ssh(Kbb, Kmm, Kaa)
       !!---------------------------------------------------------------------- 
@@ -184,6 +186,6 @@
          zdssmask(:,:) = ssmask(:,:) - zssmask0(:,:)
          DO_2D( 0, 0, 0, 0 )
-            jip1=ji+1; jim1=ji-1;
-            jjp1=jj+1; jjm1=jj-1;
+            jip1=ji+1   ;   jim1=ji-1
+            jjp1=jj+1   ;   jjm1=jj-1
             !
             zsummsk = zssmask0(jip1,jj) + zssmask0(jim1,jj) + zssmask0(ji,jjp1) + zssmask0(ji,jjm1)
@@ -191,7 +193,7 @@
             IF (zdssmask(ji,jj) == 1._wp .AND. zsummsk /= 0._wp) THEN
                ssh(ji,jj,Kmm)=( zssh(jip1,jj)*zssmask0(jip1,jj)     &
-               &           + zssh(jim1,jj)*zssmask0(jim1,jj)     &
-               &           + zssh(ji,jjp1)*zssmask0(ji,jjp1)     &
-               &           + zssh(ji,jjm1)*zssmask0(ji,jjm1)) / zsummsk
+                  &           + zssh(jim1,jj)*zssmask0(jim1,jj)     &
+                  &           + zssh(ji,jjp1)*zssmask0(ji,jjp1)     &
+                  &           + zssh(ji,jjm1)*zssmask0(ji,jjm1)) / zsummsk
                zssmask_b(ji,jj) = 1._wp
             ENDIF
@@ -222,9 +224,10 @@
       CALL dom_vvl_zgr(Kbb, Kmm, Kaa)
 #else
-      CALL dom_qco_zgr(Kbb, Kmm, Kaa)
+      CALL dom_qco_zgr(Kbb, Kmm)
 #endif
       !
    END SUBROUTINE isfcpl_ssh
 
+   
    SUBROUTINE isfcpl_tra(Kmm)
       !!---------------------------------------------------------------------- 
@@ -375,4 +378,5 @@
       ! 
    END SUBROUTINE isfcpl_tra
+   
 
    SUBROUTINE isfcpl_vol(Kmm)
@@ -466,7 +470,8 @@
          risfcpl_ssh(:,:) = risfcpl_ssh(:,:) + risfcpl_vol(:,:,jk) * r1_e1e2t(:,:)
       END DO
-
+      !
    END SUBROUTINE isfcpl_vol
 
+   
    SUBROUTINE isfcpl_cons(Kmm)
       !!---------------------------------------------------------------------- 
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfdynatf.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfdynatf.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfdynatf.F90	(revision 14062)
@@ -15,5 +15,5 @@
    USE phycst , ONLY: r1_rho0         ! physical constant
    USE dom_oce                        ! time and space domain
-   USE oce, ONLY : ssh                ! sea-surface height !!st needed for substitution
+   USE oce, ONLY : ssh                ! sea-surface height for qco substitution
 
    USE in_out_manager
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfrst.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfrst.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/ISF/isfrst.F90	(revision 14062)
@@ -28,6 +28,6 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   ! 
-   SUBROUTINE isfrst_read(cdisf, ptsc, pfwf, ptsc_b, pfwf_b )
+   
+   SUBROUTINE isfrst_read( cdisf, ptsc, pfwf, ptsc_b, pfwf_b )
       !!---------------------------------------------------------------------
       !!
@@ -51,5 +51,5 @@
       !
       ! read restart
-      IF( iom_varid( numror, cfwf_b, ldstop = .FALSE. ) > 0 ) THEN
+      IF( .NOT.l_1st_euler ) THEN
          IF(lwp) WRITE(numout,*) '          nit000-1 isf tracer content forcing fields read in the restart file'
          CALL iom_get( numror, jpdom_auto, cfwf_b, pfwf_b(:,:)         )   ! before ice shelf melt
@@ -62,6 +62,7 @@
       !
    END SUBROUTINE isfrst_read
-   ! 
-   SUBROUTINE isfrst_write(kt, cdisf, ptsc, pfwf )
+
+   
+   SUBROUTINE isfrst_write( kt, cdisf, ptsc, pfwf )
       !!---------------------------------------------------------------------
       !!
@@ -94,4 +95,5 @@
       !
    END SUBROUTINE isfrst_write
-   !
+   
+   !!======================================================================
 END MODULE isfrst
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/LDF/ldfdyn.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/LDF/ldfdyn.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/OCE/LDF/ldfdyn.F90	(revision 14062)
@@ -34,4 +34,5 @@
    !                                    !!* Namelist namdyn_ldf : lateral mixing on momentum *
    LOGICAL , PUBLIC ::   ln_dynldf_OFF   !: No operator (i.e. no explicit diffusion)
+   INTEGER , PUBLIC ::   nn_dynldf_typ   !: operator type (0: div-rot ; 1: symmetric)
    LOGICAL , PUBLIC ::   ln_dynldf_lap   !: laplacian operator
    LOGICAL , PUBLIC ::   ln_dynldf_blp   !: bilaplacian operator
@@ -52,6 +53,10 @@
 
    !                                    !!* Parameter to control the type of lateral viscous operator
-   INTEGER, PARAMETER, PUBLIC ::   np_ERROR  =-10                       !: error in setting the operator
-   INTEGER, PARAMETER, PUBLIC ::   np_no_ldf = 00                       !: without operator (i.e. no lateral viscous trend)
+   INTEGER, PARAMETER, PUBLIC ::   np_ERROR   =-10                      !: error in setting the operator
+   INTEGER, PARAMETER, PUBLIC ::   np_no_ldf  = 00                      !: without operator (i.e. no lateral viscous trend)
+   !
+   INTEGER, PARAMETER, PUBLIC ::   np_typ_rot = 0                       !: div-rot   operator
+   INTEGER, PARAMETER, PUBLIC ::   np_typ_sym = 1                       !: symmetric operator
+   !
    !                          !!      laplacian     !    bilaplacian    !
    INTEGER, PARAMETER, PUBLIC ::   np_lap    = 10   ,   np_blp    = 20  !: iso-level operator
@@ -109,8 +114,8 @@
       CHARACTER(len=5) ::   cl_Units               ! units (m2/s or m4/s)
       !!
-      NAMELIST/namdyn_ldf/ ln_dynldf_OFF, ln_dynldf_lap, ln_dynldf_blp,   &   ! type of operator
-         &                 ln_dynldf_lev, ln_dynldf_hor, ln_dynldf_iso,   &   ! acting direction of the operator
-         &                 nn_ahm_ijk_t , rn_Uv    , rn_Lv,   rn_ahm_b,   &   ! lateral eddy coefficient
-         &                 rn_csmc      , rn_minfac    , rn_maxfac            ! Smagorinsky settings
+      NAMELIST/namdyn_ldf/ ln_dynldf_OFF, nn_dynldf_typ, ln_dynldf_lap, ln_dynldf_blp,   &   ! type of operator
+         &                 ln_dynldf_lev, ln_dynldf_hor, ln_dynldf_iso,                  &   ! acting direction of the operator
+         &                 nn_ahm_ijk_t , rn_Uv        , rn_Lv        ,   rn_ahm_b,      &   ! lateral eddy coefficient
+         &                 rn_csmc      , rn_minfac    , rn_maxfac                           ! Smagorinsky settings
       !!----------------------------------------------------------------------
       !
@@ -130,4 +135,5 @@
          WRITE(numout,*) '      type :'
          WRITE(numout,*) '         no explicit diffusion                ln_dynldf_OFF = ', ln_dynldf_OFF
+         WRITE(numout,*) '         type of operator (div-rot or sym)    nn_dynldf_typ = ', nn_dynldf_typ
          WRITE(numout,*) '         laplacian operator                   ln_dynldf_lap = ', ln_dynldf_lap
          WRITE(numout,*) '         bilaplacian operator                 ln_dynldf_blp = ', ln_dynldf_blp
@@ -147,6 +153,6 @@
          WRITE(numout,*) '         Smagorinsky coefficient              rn_csmc       = ', rn_csmc
          WRITE(numout,*) '         factor multiplier for eddy visc.'
-         WRITE(numout,*) '            lower limit (default 1.0)         rn_minfac    = ', rn_minfac
-         WRITE(numout,*) '            upper limit (default 1.0)         rn_maxfac    = ', rn_maxfac
+         WRITE(numout,*) '            lower limit (default 1.0)         rn_minfac     = ', rn_minfac
+         WRITE(numout,*) '            upper limit (default 1.0)         rn_maxfac     = ', rn_maxfac
       ENDIF
 
@@ -160,12 +166,20 @@
       IF( ln_dynldf_lap ) THEN   ;                              ioptio = ioptio + 1   ;   ENDIF
       IF( ln_dynldf_blp ) THEN   ;                              ioptio = ioptio + 1   ;   ENDIF
-      IF( ioptio /= 1   )   CALL ctl_stop( 'dyn_ldf_init: use ONE of the 3 operator options (NONE/lap/blp)' )
+      IF( ioptio /= 1   )   CALL ctl_stop( 'ldf_dyn_init: use ONE of the 3 operator options (NONE/lap/blp)' )
       !
       IF(.NOT.ln_dynldf_OFF ) THEN     !==  direction ==>> type of operator  ==!
+         !
+         SELECT CASE( nn_dynldf_typ )  ! div-rot or symmetric
+         CASE( np_typ_rot )   ;   IF(lwp)   WRITE(numout,*) '   ==>>>   use div-rot   operator '
+         CASE( np_typ_sym )   ;   IF(lwp)   WRITE(numout,*) '   ==>>>   use symmetric operator '
+         CASE DEFAULT                                     ! error
+            CALL ctl_stop('ldf_dyn_init: wrong value for nn_dynldf_typ (0 or 1)'  )
+         END SELECT
+         !
          ioptio = 0
          IF( ln_dynldf_lev )   ioptio = ioptio + 1
          IF( ln_dynldf_hor )   ioptio = ioptio + 1
          IF( ln_dynldf_iso )   ioptio = ioptio + 1
-         IF( ioptio /= 1   )   CALL ctl_stop( 'dyn_ldf_init: use ONE of the 3 direction options (level/hor/iso)' )
+         IF( ioptio /= 1   )   CALL ctl_stop( 'ldf_dyn_init: use ONE of the 3 direction options (level/hor/iso)' )
          !
          !                             ! Set nldf_dyn, the type of lateral diffusion, from ln_dynldf_... logicals
